package com.inca.npbusi.sales.bms_sa_receive;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.util.SendHelper;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.pubsrv.Entrychose;
import java.util.Vector;

public class Bms_sales_receive_mde extends CMdeModelAp {
   private String a = "";
   private String b = "";

   public String getEntryid() {
      return this.a;
   }

   public void setEntryid(String var1) {
      this.a = var1;
   }

   public String getEntryname() {
      return this.b;
   }

   public void setEntryname(String var1) {
      this.b = var1;
   }

   public Bms_sales_receive_mde(CFrame var1, String var2) {
      super(var1, var2);
      this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
      this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
   }

   protected CMasterModel createMastermodel() {
      return new Bms_sales_receive_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Bms_sales_receive_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "salesid";
   }

   public String getDetailRelatecolname() {
      return "salesid";
   }

   public String getSaveCommandString() {
      return "Bms_sales_receive_mde.销售回执管理";
   }

   protected int on_actionPerformed(String var1) {
      if (!"回执确认".equals(var1)) {
         if ("取消回执".equals(var1)) {
            this.a();
            return 0;
         } else if (var1.equals("切换独立单元")) {
            if (this.mastermodel.getModifiedDbmodel().getRowCount() > 0) {
               this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
               return -1;
            } else {
               if (Entrychose.setUserEntryInfo(this.frame)) {
                  this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
                  this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
                  this.getMasterModel().doRetrieve("1=2");
               }

               return 0;
            }
         } else {
            return super.on_actionPerformed(var1);
         }
      } else {
         Bms_sales_receive_mde var12 = this;
         if (this.getMasterModel().getRow() < 0) {
            this.warnMessage("警告", "请选择正确的单据进行回执确认!");
         } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
            this.warnMessage("警告", "请选择正确的单据进行回执确认!");
         } else {
            int[] var2;
            int var3 = (var2 = this.getMasterModel().getTable().getSelectedRows()).length;
            if (var2[var2.length - 1] == this.getMasterModel().getRowCount()) {
               --var3;
            }

            DBTableModel var4 = b();

            for(int var5 = 0; var5 < var3; ++var5) {
               String var6 = var12.getMasterModel().getItemValue(var2[var5], "receiveflag");
               if (!"0".equals(var6)) {
                  var12.warnMessage("警告", "第" + (var2[var5] + 1) + "条单据的销售回执标志不是未回执，不能回执确认!");
                  return 0;
               }

               String var7 = var12.getMasterModel().getItemValue(var2[var5], "salesid");
               int var14 = var4.getRowCount();
               var4.appendRow();
               var4.setItemValue(var14, "salesid", var7);
            }

            ClientRequest var13 = new ClientRequest();
            StringCommand var15 = new StringCommand("Bms_sales_receive_mde.销售回执确认");
            DataCommand var17;
            (var17 = new DataCommand()).setDbmodel(var4);
            var13.addCommand(var15);
            var13.addCommand(var17);
            var12.setWaitCursor();

            try {
               ServerResponse var16 = SendHelper.sendRequest(var13);
               var12.a(var16, "回执确认");
            } catch (Exception var10) {
               var12.errorMessage("错误", "提交不成功!");
               var10.printStackTrace();
            } finally {
               var12.setDefaultCursor();
            }
         }

         return 0;
      }
   }

   private void a() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行回执取消!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行回执取消!");
      } else {
         int[] var1;
         int var2 = (var1 = this.getMasterModel().getTable().getSelectedRows()).length;
         if (var1[var1.length - 1] == this.getMasterModel().getRowCount()) {
            --var2;
         }

         DBTableModel var3 = b();

         for(int var4 = 0; var4 < var2; ++var4) {
            String var5 = this.getMasterModel().getItemValue(var1[var4], "receiveflag");
            if (!"1".equals(var5)) {
               this.warnMessage("警告", "第" + (var1[var4] + 1) + "条单据的销售回执标志不是已回执，不能取消回执!");
               return;
            }

            String var6 = this.getMasterModel().getItemValue(var1[var4], "salesid");
            int var12 = var3.getRowCount();
            var3.appendRow();
            var3.setItemValue(var12, "salesid", var6);
         }

         ClientRequest var11 = new ClientRequest();
         StringCommand var13 = new StringCommand("Bms_sales_receive_mde.销售回执取消");
         DataCommand var15;
         (var15 = new DataCommand()).setDbmodel(var3);
         var11.addCommand(var13);
         var11.addCommand(var15);
         this.setWaitCursor();

         try {
            ServerResponse var14 = SendHelper.sendRequest(var11);
            this.a(var14, "回执取消");
            return;
         } catch (Exception var9) {
            this.errorMessage("错误", "提交不成功!");
            var9.printStackTrace();
         } finally {
            this.setDefaultCursor();
         }

      }
   }

   private static DBTableModel b() {
      Vector var0 = new Vector();
      DBColumnDisplayInfo var1 = new DBColumnDisplayInfo("salesid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("message", "varchar");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("receiveflag", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("receivemanid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("receivedate", "date");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("receivemanname", "varchar");
      var0.add(var1);
      return new DBTableModel(var0);
   }

   private void a(ServerResponse var1, String var2) {
      String var3;
      if (!(var3 = var1.getCommand()).startsWith("+OK")) {
         this.errorMessage("错误", var3);
      } else {
         DBTableModel var10 = this.getMasterModel().getDBtableModel();
         DBTableModel var9 = ((DataCommand)var1.commandAt(1)).getDbmodel();

         for(int var4 = 0; var4 < var9.getRowCount(); ++var4) {
            String var5 = var9.getItemValue(var4, "salesid");
            String var6 = var9.getItemValue(var4, "message");

            for(int var7 = 0; var7 < var10.getRowCount(); ++var7) {
               if (var10.getItemValue(var7, "salesid").equals(var5)) {
                  if (!var6.startsWith("+OK")) {
                     var10.getRecordThunk(var7).setSaveresult(1, var6);
                     break;
                  }

                  for(int var11 = 2; var11 <= 5; ++var11) {
                     var6 = var9.getColumnDBName(var11);
                     var10.setItemValue(var7, var6, var9.getItemValue(var4, var6));
                  }

                  var10.setdbStatus(var7, 0);
                  var10.getRecordThunk(var7).setSaveresult(0, var2 + "成功");
                  break;
               }
            }
         }

         this.getMasterModel().tableChanged();
      }
   }
}
